#include <algorithm>
#include <cstdint>
#include <iostream>
#include <numeric>
#include <vector>

int main() {
    int32_t n;
    std::cin >> n;

    std::vector<int64_t> a(n), b(n);
    for (auto i = 0; i < n; ++i) {
        std::cin >> a[i] >> b[i];
    }

    int64_t aTotal = std::accumulate(a.begin(), a.end(), int64_t{});

    // dp[x] = min work b can have if a has exactly x
    std::vector<int64_t> dp(aTotal + 1, 0);
    for (auto i = 0; i < n; ++i) {
        for (auto j = aTotal; j >= 0; --j) {
            dp[j] += b[i];
            if (j >= a[i]) {
                dp[j] = std::min(dp[j], dp[j - a[i]]);
            }
        }
    }

    int64_t ans = aTotal;
    for (int64_t j = 0; j <= aTotal; ++j) {
        ans = std::min(ans, std::max(j, dp[j]));
    }

    std::cout << ans << '\n';

    return 0;
}
