import java.util.*;

/**
 * Use dynamic programming. 
 * Process one day at a time and try giving the task to intern A and try giving it to intern B.
 * dp[i][j] is the minimum number of days needed by intern A to have intern B finish on day j,
 *          when the first i tasks are split between them.
 *
 * @author Finn Lidbetter
 */

public class arrested_finn {
    static int TASK_DAYS_MAX = 100000;

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int[] aDays = new int[n];
        int[] bDays = new int[n];
        
        for (int i=0; i<n; i++) {
            aDays[i] = sc.nextInt();
            bDays[i] = sc.nextInt();
        }
        int daysMax = TASK_DAYS_MAX * n;
        // dp[i][j] is the minimum number of days needed by the first intern
        // to have the second intern finish on day j, when the first i tasks
        // are split between them.
        int[] prev = new int[daysMax + 1];
        int[] curr = new int[daysMax + 1];
        Arrays.fill(prev, -1);
        prev[0] = 0;
        for (int i=0; i<n; i++) {
            curr = new int[daysMax + 1];
            Arrays.fill(curr, -1);
            for (int j=0; j<=daysMax; j++) {
                if (prev[j]!=-1) {
                    // Try giving it to intern 1.
                    if (curr[j] == -1 || prev[j] + aDays[i] < curr[j]) {
                        curr[j] = prev[j] + aDays[i];
                    }
                    // Try giving it to intern 2.
                    if (curr[j+bDays[i]] == -1 || prev[j] < curr[j+bDays[i]]) {
                        curr[j+bDays[i]] = prev[j];
                    }
                }
            }
            prev = curr;
        }
        int minDays = daysMax + 1;
        for (int i=0; i<=daysMax; i++) {
            if (curr[i]!=-1) {
                int days = curr[i];
                if (i>days) {
                    days = i;
                }
                if (days<minDays) {
                    minDays = days;
                }
            }
            if (i>minDays) {
                break;
            }
        }
        System.out.println(minDays);
    }
}
